# Blitter_32bppBase Class Reference

Inheritance diagram for Blitter_32bppBase:

## Public Member Functions
uint8 | GetScreenDepth ()
| Get the screen depth this blitter works for.
void * | MoveTo (const void *video, int x, int y)
| Move the destination pointer the requested amount x and y, keeping in mind any pitch and bpp of the renderer.
void | SetPixel (void *video, int x, int y, uint8 colour)
| Draw a pixel with a given colour on the video-buffer.
void | DrawRect (void *video, int width, int height, uint8 colour)
| Make a single horizontal line in a single colour on the video-buffer.
void | DrawLine (void *video, int x, int y, int x2, int y2, int screen_width, int screen_height, uint8 colour)
| Draw a line with a given colour.
void | CopyFromBuffer (void *video, const void *src, int width, int height)
| Copy from a buffer to the screen.
void | CopyToBuffer (const void *video, void *dst, int width, int height)
| Copy from the screen to a buffer.
void | CopyImageToBuffer (const void *video, void *dst, int width, int height, int dst_pitch)
| Copy from the screen to a buffer in a palette format for 8bpp and RGBA format for 32bpp.
void | ScrollBuffer (void *video, int &left, int &top, int &width, int &height, int scroll_x, int scroll_y)
| Scroll the videobuffer some 'x' and 'y' value.
int | BufferSize (int width, int height)
| Calculate how much memory there is needed for an image of this size in the video-buffer.
void | PaletteAnimate (uint start, uint count)
| Called when the 8bpp palette is changed; you should redraw all pixels on the screen that are equal to the 8bpp palette indexes 'start' to 'start + count'.
Blitter::PaletteAnimation | UsePaletteAnimation ()
| Check if the blitter uses palette animation at all.
int | GetBytesPerPixel ()
| Get how many bytes are needed to store a pixel.
## Static Public Member Functions
static uint32 | ComposeColour (uint a, uint r, uint g, uint b)
| Compose a colour based on RGB values.
static uint32 | LookupColourInPalette (uint index)
| Look up the colour in the current palette.
static uint32 | ComposeColourRGBANoCheck (uint r, uint g, uint b, uint a, uint32 current)
| Compose a colour based on RGBA values and the current pixel value.
static uint32 | ComposeColourRGBA (uint r, uint g, uint b, uint a, uint32 current)
| Compose a colour based on RGBA values and the current pixel value.
static uint32 | ComposeColourPANoCheck (uint32 colour, uint a, uint32 current)
| Compose a colour based on Pixel value, alpha value, and the current pixel value.
static uint32 | ComposeColourPA (uint32 colour, uint a, uint32 current)
| Compose a colour based on Pixel value, alpha value, and the current pixel value.
static uint32 | MakeTransparent (uint32 colour, uint nom, uint denom=256)
| Make a pixel looks like it is transparent.
static uint32 | MakeGrey (uint32 colour)
| Make a colour grey - based.

## Detailed Description

Definition at line 19 of file 32bpp_base.hpp.

## Member Function Documentation

int Blitter_32bppBase::BufferSize | ( | int | width,
|  | int | height |
| ) |  |  | `[virtual]`

Calculate how much memory there is needed for an image of this size in the video-buffer.

Parameters:

  | width | The width of the buffer-to-be.
  | height | The height of the buffer-to-be.

Returns:
  The size needed for the buffer.

Implements Blitter.

Reimplemented in Blitter_32bppAnim.

Definition at line 184 of file 32bpp_base.cpp.

static uint32 Blitter_32bppBase::ComposeColourPA | ( | uint32 | colour,
|  | uint | a,
|  | uint32 | current |
| ) |  |  | `[inline, static]`

Compose a colour based on Pixel value, alpha value, and the current pixel value.

Handles fully transparent and solid pixels in a special (faster) way.

Definition at line 98 of file 32bpp_base.hpp.

References ComposeColourPANoCheck().

Referenced by Blitter_32bppSimple::Draw().

static uint32 Blitter_32bppBase::ComposeColourRGBA | ( | uint | r,
|  | uint | g,
|  | uint | b,
|  | uint | a,
|  | uint32 | current |
| ) |  |  | `[inline, static]`

Compose a colour based on RGBA values and the current pixel value.

Handles fully transparent and solid pixels in a special (faster) way.

Definition at line 74 of file 32bpp_base.hpp.

References ComposeColour(), and ComposeColourRGBANoCheck().

Referenced by Blitter_32bppSimple::Draw().

void Blitter_32bppBase::CopyFromBuffer | ( | void * | video,
|  | const void * | src,
|  | int | width,
|  | int | height |
| ) |  |  | `[virtual]`

Copy from a buffer to the screen.

Parameters:

  | video | The destionation pointer (video-buffer).
  | src | The buffer from which the data will be read.
  | width | The width of the buffer.
  | height | The height of the buffer.

Note:
  You can not do anything with the content of the buffer, as the blitter can store non-pixel data in it too!

Implements Blitter.

Reimplemented in Blitter_32bppAnim.

Definition at line 89 of file 32bpp_base.cpp.

void Blitter_32bppBase::CopyImageToBuffer | ( | const void * | video,
|  | void * | dst,
|  | int | width,
|  | int | height,
|  | int | dst_pitch |
| ) |  |  | `[virtual]`

Copy from the screen to a buffer in a palette format for 8bpp and RGBA format for 32bpp.

Parameters:

  | video | The destination pointer (video-buffer).
  | dst | The buffer in which the data will be stored.
  | width | The width of the buffer.
  | height | The height of the buffer.
  | dst_pitch | The pitch (byte per line) of the destination buffer.

Implements Blitter.

Definition at line 113 of file 32bpp_base.cpp.

void Blitter_32bppBase::CopyToBuffer | ( | const void * | video,
|  | void * | dst,
|  | int | width,
|  | int | height |
| ) |  |  | `[virtual]`

Copy from the screen to a buffer.

Parameters:

  | video | The destination pointer (video-buffer).
  | dst | The buffer in which the data will be stored.
  | width | The width of the buffer.
  | height | The height of the buffer.

Note:
  You can not do anything with the content of the buffer, as the blitter can store non-pixel data in it too!

Implements Blitter.

Reimplemented in Blitter_32bppAnim.

Definition at line 101 of file 32bpp_base.cpp.

void Blitter_32bppBase::DrawLine | ( | void * | video,
|  | int | x,
|  | int | y,
|  | int | x2,
|  | int | y2,
|  | int | screen_width,
|  | int | screen_height,
|  | uint8 | colour |
| ) |  |  | `[virtual]`

Draw a line with a given colour.

Parameters:

  | video | The destination pointer (video-buffer).
  | x | The x coordinate from where the line starts.
  | y | The y coordinate from where the line starts.
  | x2 | The x coordinate to where the line goes.
  | y2 | The y coordinate to where the lines goes.
  | screen_width | The width of the screen you are drawing in (to avoid buffer-overflows).
  | screen_height | The height of the screen you are drawing in (to avoid buffer-overflows).
  | colour | A 8bpp mapping colour.

Implements Blitter.

Definition at line 39 of file 32bpp_base.cpp.

References SetPixel().

void Blitter_32bppBase::DrawRect | ( | void * | video,
|  | int | width,
|  | int | height,
|  | uint8 | colour |
| ) |  |  | `[virtual]`

Make a single horizontal line in a single colour on the video-buffer.

Parameters:

  | video | The destination pointer (video-buffer).
  | width | The length of the line.
  | height | The height of the line.
  | colour | A 8bpp mapping colour.

Implements Blitter.

Reimplemented in Blitter_32bppAnim.

Definition at line 25 of file 32bpp_base.cpp.

References LookupColourInPalette().

uint8 Blitter_32bppBase::GetScreenDepth | ( |  | ) | `[inline, virtual]`

Get the screen depth this blitter works for.

This is either: 8, 16, 24 or 32.

Implements Blitter.

Definition at line 21 of file 32bpp_base.hpp.

static uint32 Blitter_32bppBase::MakeGrey | ( | uint32 | colour | ) | `[inline, static]`

Make a colour grey - based.

Parameters:

  | colour | the colour to make grey.

Returns:
  the new colour, now grey.

Definition at line 127 of file 32bpp_base.hpp.

References ComposeColour(), and GB().

Referenced by Blitter_32bppSimple::DrawColourMappingRect(), and Blitter_32bppAnim::DrawColourMappingRect().

static uint32 Blitter_32bppBase::MakeTransparent | ( | uint32 | colour,
|  | uint | nom,
|  | uint | denom = `256` |
| ) |  |  | `[inline, static]`

Make a pixel looks like it is transparent.

Parameters:

  | colour | the colour already on the screen.
  | nom | the amount of transparency, nominator, makes colour lighter.
  | denom | denominator, makes colour darker.

Returns:
  the new colour for the screen.

Definition at line 113 of file 32bpp_base.hpp.

References ComposeColour(), and GB().

Referenced by Blitter_32bppSimple::Draw(), Blitter_32bppOptimized::Draw(), Blitter_32bppAnim::Draw(), Blitter_32bppSimple::DrawColourMappingRect(), and Blitter_32bppAnim::DrawColourMappingRect().

void * Blitter_32bppBase::MoveTo | ( | const void * | video,
|  | int | x,
|  | int | y |
| ) |  |  | `[virtual]`

Move the destination pointer the requested amount x and y, keeping in mind any pitch and bpp of the renderer.

Parameters:

  | video | The destination pointer (video-buffer) to scroll.
  | x | How much you want to scroll to the right.
  | y | How much you want to scroll to the bottom.

Returns:
  A new destination pointer moved the the requested place.

Implements Blitter.

Definition at line 15 of file 32bpp_base.cpp.

void Blitter_32bppBase::PaletteAnimate | ( | uint | start,
|  | uint | count |
| ) |  |  | `[virtual]`

Called when the 8bpp palette is changed; you should redraw all pixels on the screen that are equal to the 8bpp palette indexes 'start' to 'start + count'.

Parameters:

  | start | The start index in the 8bpp palette.
  | count | The amount of indexes that are (possible) changed.

Implements Blitter.

Reimplemented in Blitter_32bppAnim.

Definition at line 189 of file 32bpp_base.cpp.

void Blitter_32bppBase::ScrollBuffer | ( | void * | video,
|  | int & | left,
|  | int & | top,
|  | int & | width,
|  | int & | height,
|  | int | scroll_x,
|  | int | scroll_y |
| ) |  |  | `[virtual]`

Scroll the videobuffer some 'x' and 'y' value.

Parameters:

  | video | The buffer to scroll into.
  | left | The left value of the screen to scroll.
  | top | The top value of the screen to scroll.
  | width | The width of the screen to scroll.
  | height | The height of the screen to scroll.
  | scroll_x | How much to scroll in X.
  | scroll_y | How much to scroll in Y.

Implements Blitter.

Reimplemented in Blitter_32bppAnim.

Definition at line 125 of file 32bpp_base.cpp.

void Blitter_32bppBase::SetPixel | ( | void * | video,
|  | int | x,
|  | int | y,
|  | uint8 | colour |
| ) |  |  | `[virtual]`

Draw a pixel with a given colour on the video-buffer.

Parameters:

  | video | The destination pointer (video-buffer).
  | x | The x position within video-buffer.
  | y | The y position within video-buffer.
  | colour | A 8bpp mapping colour.

Implements Blitter.

Reimplemented in Blitter_32bppAnim.

Definition at line 20 of file 32bpp_base.cpp.

References LookupColourInPalette().

Referenced by DrawLine().

Blitter::PaletteAnimation Blitter_32bppBase::UsePaletteAnimation | ( |  | ) | `[virtual]`

Check if the blitter uses palette animation at all.

Returns:
  True if it uses palette animation.

Implements Blitter.

Reimplemented in Blitter_32bppAnim.

Definition at line 194 of file 32bpp_base.cpp.

References Blitter::PALETTE_ANIMATION_NONE.

The documentation for this class was generated from the following files:

- src/blitter/32bpp_base.hpp
- src/blitter/32bpp_base.cpp